# Ipopt::IterativeWsmpSolverInterface Class Reference

Interface to the linear solver WISMP, derived from SparseSymLinearSolverInterface. More...

`#include <IpIterativeWsmpSolverInterface.hpp>`

Inheritance diagram for Ipopt::IterativeWsmpSolverInterface:
[legend]

List of all members.

## Public Member Functions
bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| overloaded from AlgorithmStrategyObject
Constructor/Destructor
| IterativeWsmpSolverInterface ()
| Constructor.
virtual | ~IterativeWsmpSolverInterface ()
| Destructor.
Methods for requesting solution of the linear system.
virtual ESymSolverStatus | InitializeStructure (Index dim, Index nonzeros, const Index *ia, const Index *ja)
| Method for initializing internal stuctures.
virtual double * | GetValuesArrayPtr ()
| Method returing an internal array into which the nonzero elements are to be stored.
virtual ESymSolverStatus | MultiSolve (bool new_matrix, const Index *ia, const Index *ja, Index nrhs, double *rhs_vals, bool check_NegEVals, Index numberOfNegEVals)
| Solve operation for multiple right hand sides.
virtual Index | NumberOfNegEVals () const
| Number of negative eigenvalues detected during last factorization.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| IterativeWsmpSolverInterface (const IterativeWsmpSolverInterface &)
| Copy Constructor.
void | operator= (const IterativeWsmpSolverInterface &)
| Overloaded Equals Operator.
Internal functions
ESymSolverStatus | SymbolicFactorization (const Index *ia, const Index *ja)
| Call Wsmp to do the analysis phase.
ESymSolverStatus | InternalSymFact (const Index *ia, const Index *ja)
| Call Wsmp to really do the analysis phase.
ESymSolverStatus | Factorization (const Index *ia, const Index *ja, bool check_NegEVals, Index numberOfNegEVals)
| Call Wsmp to factorize the Matrix.
ESymSolverStatus | Solve (const Index *ia, const Index *ja, Index nrhs, double *rhs_vals)
| Call Wsmpx to do the Solve.
## Private Attributes
Index | matrix_file_number_
| Counter for matrix file numbers.
Information about the matrix
Index | dim_
| Number of rows and columns of the matrix.
double * | a_
| Array for storing the values of the matrix.
Solver specific options
Index | wsmp_num_threads_
| Option that controls the matching strategy.
Number | wsmp_pivtol_
| Pivol tolerance.
Number | wsmp_pivtolmax_
| Maximal pivot tolerance.
Index | wsmp_scaling_
| Indicating which of WSMP's scaling methods should be used.
Index | wsmp_write_matrix_iteration_
| iteration number in which matrices are to be written out
Number | wsmp_inexact_droptol_
Number | wsmp_inexact_fillin_limit_
Initialization flags
bool | initialized_
| Flag indicating if internal data is initialized.
bool | pivtol_changed_
| Flag indicating if the matrix has to be refactorized because the pivot tolerance has been changed.
bool | have_symbolic_factorization_
| Flag indicating whether symbolic factorization and order has already been performed.
Solver specific information
ipfint * | IPARM_
| Integer parameter array for WISMP.
double * | DPARM_
| Double precision parameter array for WISMP.
virtual bool | IncreaseQuality ()
| Request to increase quality of solution for next solve.
virtual bool | ProvidesInertia () const
| Query whether inertia is computed by linear solver.
EMatrixFormat | MatrixFormat () const
| Query of requested matrix type that the linear solver understands.
static void | RegisterOptions (SmartPtr< RegisteredOptions > roptions)
| Methods for IpoptType.

## Detailed Description

Interface to the linear solver WISMP, derived from SparseSymLinearSolverInterface.

For details, see description of SparseSymLinearSolverInterface base class.

Definition at line 23 of file IpIterativeWsmpSolverInterface.hpp.

## Constructor & Destructor Documentation

Ipopt::IterativeWsmpSolverInterface::IterativeWsmpSolverInterface | ( |  | ) |

Constructor.

virtual Ipopt::IterativeWsmpSolverInterface::~IterativeWsmpSolverInterface | ( |  | ) | `[virtual]`

Destructor.

Ipopt::IterativeWsmpSolverInterface::IterativeWsmpSolverInterface | ( | const IterativeWsmpSolverInterface & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

bool Ipopt::IterativeWsmpSolverInterface::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::IterativeWsmpSolverInterface::InitializeStructure | ( | Index | dim,
|  | Index | nonzeros,
|  | const Index * | ia,
|  | const Index * | ja |
| ) |  |  | `[virtual]`

Method for initializing internal stuctures.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual double* Ipopt::IterativeWsmpSolverInterface::GetValuesArrayPtr | ( |  | ) | `[virtual]`

Method returing an internal array into which the nonzero elements are to be stored.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::IterativeWsmpSolverInterface::MultiSolve | ( | bool | new_matrix,
|  | const Index * | ia,
|  | const Index * | ja,
|  | Index | nrhs,
|  | double * | rhs_vals,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[virtual]`

Solve operation for multiple right hand sides.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual Index Ipopt::IterativeWsmpSolverInterface::NumberOfNegEVals | ( |  | ) | const`[virtual]`

Number of negative eigenvalues detected during last factorization.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::IterativeWsmpSolverInterface::IncreaseQuality | ( |  | ) | `[virtual]`

Request to increase quality of solution for next solve.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::IterativeWsmpSolverInterface::ProvidesInertia | ( |  | ) | const`[inline, virtual]`

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 75 of file IpIterativeWsmpSolverInterface.hpp.

EMatrixFormat Ipopt::IterativeWsmpSolverInterface::MatrixFormat | ( |  | ) | const`[inline, virtual]`

Query of requested matrix type that the linear solver understands.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 82 of file IpIterativeWsmpSolverInterface.hpp.

static void Ipopt::IterativeWsmpSolverInterface::RegisterOptions | ( | SmartPtr< RegisteredOptions > | roptions | ) | `[static]`

Methods for IpoptType.

void Ipopt::IterativeWsmpSolverInterface::operator= | ( | const IterativeWsmpSolverInterface & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented from Ipopt::AlgorithmStrategyObject.

ESymSolverStatus Ipopt::IterativeWsmpSolverInterface::SymbolicFactorization | ( | const Index * | ia,
|  | const Index * | ja |
| ) |  |  | `[private]`

Call Wsmp to do the analysis phase.

ESymSolverStatus Ipopt::IterativeWsmpSolverInterface::InternalSymFact | ( | const Index * | ia,
|  | const Index * | ja |
| ) |  |  | `[private]`

Call Wsmp to really do the analysis phase.

ESymSolverStatus Ipopt::IterativeWsmpSolverInterface::Factorization | ( | const Index * | ia,
|  | const Index * | ja,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[private]`

Call Wsmp to factorize the Matrix.

ESymSolverStatus Ipopt::IterativeWsmpSolverInterface::Solve | ( | const Index * | ia,
|  | const Index * | ja,
|  | Index | nrhs,
|  | double * | rhs_vals |
| ) |  |  | `[private]`

Call Wsmpx to do the Solve.

## Member Data Documentation

Index Ipopt::IterativeWsmpSolverInterface::dim_`[private]`

Number of rows and columns of the matrix.

Definition at line 112 of file IpIterativeWsmpSolverInterface.hpp.

double* Ipopt::IterativeWsmpSolverInterface::a_`[private]`

Array for storing the values of the matrix.

Definition at line 115 of file IpIterativeWsmpSolverInterface.hpp.

Index Ipopt::IterativeWsmpSolverInterface::wsmp_num_threads_`[private]`

Option that controls the matching strategy.

Definition at line 121 of file IpIterativeWsmpSolverInterface.hpp.

Number Ipopt::IterativeWsmpSolverInterface::wsmp_pivtol_`[private]`

Pivol tolerance.

Definition at line 123 of file IpIterativeWsmpSolverInterface.hpp.

Number Ipopt::IterativeWsmpSolverInterface::wsmp_pivtolmax_`[private]`

Maximal pivot tolerance.

Definition at line 125 of file IpIterativeWsmpSolverInterface.hpp.

Index Ipopt::IterativeWsmpSolverInterface::wsmp_scaling_`[private]`

Indicating which of WSMP's scaling methods should be used.

Definition at line 127 of file IpIterativeWsmpSolverInterface.hpp.

Index Ipopt::IterativeWsmpSolverInterface::wsmp_write_matrix_iteration_`[private]`

iteration number in which matrices are to be written out

Definition at line 129 of file IpIterativeWsmpSolverInterface.hpp.

Number Ipopt::IterativeWsmpSolverInterface::wsmp_inexact_droptol_`[private]`

Definition at line 130 of file IpIterativeWsmpSolverInterface.hpp.

Number Ipopt::IterativeWsmpSolverInterface::wsmp_inexact_fillin_limit_`[private]`

Definition at line 131 of file IpIterativeWsmpSolverInterface.hpp.

Index Ipopt::IterativeWsmpSolverInterface::matrix_file_number_`[private]`

Counter for matrix file numbers.

Definition at line 135 of file IpIterativeWsmpSolverInterface.hpp.

bool Ipopt::IterativeWsmpSolverInterface::initialized_`[private]`

Flag indicating if internal data is initialized.

For initialization, this object needs to have seen a matrix

Definition at line 149 of file IpIterativeWsmpSolverInterface.hpp.

bool Ipopt::IterativeWsmpSolverInterface::pivtol_changed_`[private]`

Flag indicating if the matrix has to be refactorized because the pivot tolerance has been changed.

Definition at line 152 of file IpIterativeWsmpSolverInterface.hpp.

bool Ipopt::IterativeWsmpSolverInterface::have_symbolic_factorization_`[private]`

Flag indicating whether symbolic factorization and order has already been performed.

Definition at line 155 of file IpIterativeWsmpSolverInterface.hpp.

ipfint* Ipopt::IterativeWsmpSolverInterface::IPARM_`[private]`

Integer parameter array for WISMP.

Definition at line 161 of file IpIterativeWsmpSolverInterface.hpp.

double* Ipopt::IterativeWsmpSolverInterface::DPARM_`[private]`

Double precision parameter array for WISMP.

Definition at line 163 of file IpIterativeWsmpSolverInterface.hpp.

The documentation for this class was generated from the following file:

- src/Algorithm/LinearSolvers/IpIterativeWsmpSolverInterface.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines